Index: issm/branches/trunk-jpl-damage/src/m/model/loadresultsfromdisk.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/loadresultsfromdisk.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/loadresultsfromdisk.py	(revision 12878)
@@ -0,0 +1,60 @@
+import os
+
+def loadresultsfromdisk(md,filename):
+	"""
+	LOADRESULTSFROMDISK - load results of solution sequence from disk file "filename"            
+ 
+	    Usage:
+	       md=loadresultsfromdisk(md=False,filename=False);
+	"""
+
+	#check number of inputs/outputs
+	if not md or not filename:
+		raise ValueError("loadresultsfromdisk: error message.")
+
+	if not md.qmu.isdakota:
+
+		#Check that file exists
+		if not os.path.exists(filename):
+			raise ValueError("binary file '%s' not found." % filename)
+
+		#initialize md.results if not a structure yet
+		if not isinstance(md.results,dict):
+			md.results={}
+
+		#load results onto model
+		structure=parseresultsfromdisk(filename,~md.settings.io_gather)
+		if not len(structure):
+			raise RuntimeError("No result found in binary file '%s'. Check for solution crash." % filename)
+		end
+		md.results[structure[1]['SolutionType']]=structure;
+
+		#recover solution_type from results
+		md.private.solution=structure[1]['SolutionType']
+
+		#read log files onto fields
+		if os.path.exists(md.miscellaneous.name+'.errlog'):
+			with open(md.miscellaneous.name+'.errlog','r') as f:
+				md.results[structure[1]['SolutionType']]['errlog']=[line[:-1] for line in f]
+		else:
+			md.results[structure[1]['SolutionType']]['errlog']=[]
+
+		if os.path.exists(md.miscellaneous.name+'.outlog'):
+			with open(md.miscellaneous.name+'.outlog','r') as f:
+				md.results[structure[1]['SolutionType']]['outlog']=[line[:-1] for line in f]
+		else:
+			md.results[structure[1]['SolutionType']]['outlog']=[]
+
+		if len(md.results[structure[1]['SolutionType']]['errlog']):
+			print ("loadresultsfromcluster info message: error during solution. Check your errlog and outlog model fields.")
+
+	#post processes qmu results if necessary
+	else:
+
+		if not isinstance(md.private.solution,str):
+			md.private.solution=EnumToString(md.private.solution)
+		md=postqmu(md)
+		os.chdir('..')
+
+	return md
+
Index: issm/branches/trunk-jpl-damage/src/m/model/marshall.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/marshall.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/marshall.m	(revision 12878)
@@ -16,5 +16,5 @@
 end
 
-%First, right MaximumNumberOfEnum to make sure that the Enums are synchronized
+%First, write MaximumNumberOfEnum to make sure that the Enums are synchronized
 WriteData(fid,'enum',MaximumNumberOfEnums(),'data',true,'format','Boolean');
 
@@ -31,5 +31,5 @@
 	%Check that current field is an object
 	if ~isobject(md.(field))
-		checkmessage(['field ''' char(field) ''' is not an object']);
+		error(['field ''' char(field) ''' is not an object']);
 	end
 
Index: issm/branches/trunk-jpl-damage/src/m/model/marshall.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/marshall.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/marshall.py	(revision 12878)
@@ -0,0 +1,47 @@
+from WriteData import *
+
+def marshall(md):
+	"""
+	MARSHALL - outputs a compatible binary file from @model md, for certain solution type.
+
+	    The routine creates a compatible binary file from @model md
+	    This binary file will be used for parallel runs in JPL-package
+
+	    Usage:
+	       marshall(md)
+	"""
+
+	print "marshalling file '%s.bin'." % md.miscellaneous.name
+
+	#open file for binary writing
+	try:
+		fid=open(md.miscellaneous.name+'.bin','wb')
+	except IOError as e:
+		raise IOError("marshall error message: could not open '%s.bin' file for binary writing." % md.miscellaneous.name)
+
+	#First, write MaximumNumberOfEnum to make sure that the Enums are synchronized
+	WriteData(fid,'enum',MaximumNumberOfEnums(),'data',true,'format','Boolean')
+
+	#Go through all model fields: check that it is a class and call checkconsistency
+	fields=vars(md)
+
+	for field in fields.interkeys():
+
+		#Some properties do not need to be marshalled
+		if field in ['results','radaroverlay','solver','cluster','flaim','private']:
+			continue
+
+		#Check that current field is an object
+		if not hasattr(getattr(md,field),'marshall'):
+			raise TypeError("field '%s' is not an object." % field)
+
+		#Marshall current object
+		#print "marshalling %s ..." % field
+		exec("md.%s.marshall(fid)" % field)
+
+	#close file
+	try:
+		f.close(fid)
+	except IOError as e:
+		raise IOError("marshall error message: could not close file '%s.bin'." % md.miscellaneous.name)
+
Index: issm/branches/trunk-jpl-damage/src/m/model/mesh/bamg.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/mesh/bamg.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/mesh/bamg.m	(revision 12878)
@@ -58,5 +58,5 @@
 bamg_mesh=bamgmesh;
 
-% Bamg Geometry parameters {{{1
+% Bamg Geometry parameters {{{
 if exist(options,'domain'),
 
@@ -259,5 +259,5 @@
 end
 %}}}
-% Bamg Mesh parameters {{{1
+% Bamg Mesh parameters {{{
 if (~exist(options,'domain') & md.mesh.numberofvertices~=0 & md.mesh.dimension==2),
 
@@ -274,5 +274,5 @@
 end
 %}}}
-% Bamg Options {{{1
+% Bamg Options {{{
 bamg_options.Crack=getfieldvalue(options,'Crack',0);
 bamg_options.anisomax=getfieldvalue(options,'anisomax',10^30);
Index: issm/branches/trunk-jpl-damage/src/m/model/modelextract.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/modelextract.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/modelextract.m	(revision 12878)
@@ -166,5 +166,5 @@
 	if size(md2.mesh.edges,2)>1, %do not use ~isnan because there are some NaNs...
 		%renumber first two columns
-		pos=find(~isnan(md2.mesh.edges(:,4)));
+		pos=find(md2.mesh.edges(:,4)~=-1);
 		md2.mesh.edges(:  ,1)=Pnode(md2.mesh.edges(:,1)); 
 		md2.mesh.edges(:  ,2)=Pnode(md2.mesh.edges(:,2)); 
@@ -173,18 +173,18 @@
 		%remove edges when the 2 vertices are not in the domain.
 		md2.mesh.edges=md2.mesh.edges(find(md2.mesh.edges(:,1) & md2.mesh.edges(:,2)),:);
-		%Replace all zeros by NaN in the last two columns;
+		%Replace all zeros by -1 in the last two columns;
 		pos=find(md2.mesh.edges(:,3)==0);
-		md2.mesh.edges(pos,3)=NaN;
+		md2.mesh.edges(pos,3)=-1;
 		pos=find(md2.mesh.edges(:,4)==0);
-		md2.mesh.edges(pos,4)=NaN;
-		%Invert NaN of the third column with last column (Also invert first two columns!!)
-		pos=find(isnan(md2.mesh.edges(:,3)));
+		md2.mesh.edges(pos,4)=-1;
+		%Invert -1 on the third column with last column (Also invert first two columns!!)
+		pos=find(md2.mesh.edges(:,3)==-1);
 		md2.mesh.edges(pos,3)=md2.mesh.edges(pos,4);
-		md2.mesh.edges(pos,4)=NaN;
+		md2.mesh.edges(pos,4)=-1;
 		values=md2.mesh.edges(pos,2);
 		md2.mesh.edges(pos,2)=md2.mesh.edges(pos,1);
 		md2.mesh.edges(pos,1)=values;
 		%Finally remove edges that do not belong to any element
-		pos=find(isnan(md2.mesh.edges(:,3)) & isnan(md2.mesh.edges(:,4)));
+		pos=find(md2.mesh.edges(:,3)==-1 & md2.mesh.edges(:,4)==-1);
 		md2.mesh.edges(pos,:)=[];
 	end
@@ -210,4 +210,14 @@
 		md2.mesh.segments=contourenvelope(md2);
 		md2.mesh.vertexonboundary=zeros(numberofvertices2,1); md2.mesh.vertexonboundary(md2.mesh.segments(:,1:2))=1;
+	else
+		%First do the connectivity for the contourenvelope in 2d
+		md2.mesh.vertexconnectivity=NodeConnectivity(md2.mesh.elements2d,md2.mesh.numberofvertices2d);
+		md2.mesh.elementconnectivity=ElementConnectivity(md2.mesh.elements2d,md2.mesh.vertexconnectivity);
+		md2.mesh.segments=contourenvelope(md2);
+		md2.mesh.vertexonboundary=zeros(numberofvertices2/md2.mesh.numberoflayers,1); md2.mesh.vertexonboundary(md2.mesh.segments(:,1:2))=1;
+		md2.mesh.vertexonboundary=repmat(md2.mesh.vertexonboundary,md2.mesh.numberoflayers,1);
+		%Then do it for 3d as usual
+		md2.mesh.vertexconnectivity=NodeConnectivity(md2.mesh.elements,md2.mesh.numberofvertices);
+		md2.mesh.elementconnectivity=ElementConnectivity(md2.mesh.elements,md2.mesh.vertexconnectivity);
 	end
 
Index: issm/branches/trunk-jpl-damage/src/m/model/parameterization/parameterize.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/parameterization/parameterize.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/parameterization/parameterize.m	(revision 12878)
@@ -4,5 +4,5 @@
 %   from a parameter matlab file, start filling in all the @model fields that were not 
 %   filled in by the mesh.m and mask.m @model methods.
-%   Warning: the paramter file must be able to be run in Matlab
+%   Warning: the parameter file must be able to be run in Matlab
 %
 %   Usage:
@@ -14,5 +14,5 @@
 %some checks
 if ~exist(parametername),
-	error(['parameterize error message: file ' parametername ' not found !']);
+	error(['parameterize error message: file ' parametername ' not found!']);
 end
 
Index: issm/branches/trunk-jpl-damage/src/m/model/parameterization/parameterize.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/parameterization/parameterize.py	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/parameterization/parameterize.py	(revision 12878)
@@ -1,27 +1,34 @@
 import os
-def  parameterize(md,parametername):
-	#PARAMETERIZE - parameterize a model
-	#
-	#   from a parameter matlab file, start filling in all the model fields that were not 
-	#   filled in by the mesh.py and setmask.py model methods.
-	#   Warning: the parameter file must be able to be run in Python
-	#
-	#   Usage:
-	#      md=parameterize(md,parametername)
-	#
-	#   Example:
-	#      md=parameterize(md,'Square.par');
+import datetime
+from addnote import *
+
+def parameterize(md,parametername):
+	"""
+	PARAMETERIZE - parameterize a model
+	 
+	    from a parameter python file, start filling in all the model fields that were not 
+	    filled in by the mesh.py and mask.py model methods.
+	    Warning: the parameter file must be able to be run in Python
+	 
+	    Usage:
+	       md=parameterize(md,parametername)
+	 
+	    Example:
+	       md=parameterize(md,'Square.par');
+	"""
 
 	#some checks
-	if not os.path.isfile(parametername):
-		print 'parameterize error message: file '+parametername+' not found.'
-		return []
+	if not os.path.exists(parametername):
+		raise IOError("parameterize error message: file '%s' not found!" % parametername)
 
 	#Try and run parameter file.
 	execfile(parametername)
-	
-	#ame and notes
-	if len(md.miscellaneous.name)==0:
-		md.miscellaneous.name=os.path.basename(parametername)
-	
-	md=addnote(md,'Model created by using parameter file: '+parametername+' on: '+str(datetime.datetime.now()))
+
+	#Name and notes
+	if not md.miscellaneous.name:
+		md.miscellaneous.name=os.path.basename(parametername).split('.')[0]
+
+	md=addnote(md,"Model created by using parameter file: '%s' on: %s." % (parametername,datetime.datetime.strftime(datetime.datetime.now(),'%c') ))
+
+	return md
+
Index: issm/branches/trunk-jpl-damage/src/m/model/parseresultsfromdisk.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/parseresultsfromdisk.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/parseresultsfromdisk.m	(revision 12878)
@@ -172,5 +172,5 @@
 % }}}
 function result=ReadDataDimensions(fid) % {{{
-%READDATA - read data dimensions, step and time, but not the data itself.
+%READDATADIMENSIONS - read data dimensions, step and time, but not the data itself.
 %
 %   Usage:
Index: issm/branches/trunk-jpl-damage/src/m/model/parseresultsfromdisk.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/parseresultsfromdisk.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/parseresultsfromdisk.py	(revision 12878)
@@ -0,0 +1,235 @@
+import struct
+import numpy
+from MatlabFuncs import *
+from MatlabProcessPatch import *
+
+def parseresultsfromdisk(filename,iosplit):
+	"""
+	PARSERESULTSFROMDISK - ...
+	 
+	    Usage:
+	       results=parseresultsfromdisk(filename,iosplit)
+	"""
+
+	if iosplit:
+		results=parseresultsfromdiskiosplit(filename)
+	else:
+		results=parseresultsfromdiskioserial(filename)
+
+	#process patch if necessary
+	results=MatlabProcessPatch(results)
+
+	return results
+
+def parseresultsfromdiskioserial(filename):    # {{{
+	"""
+	PARSERESULTSFROMDISK - ...
+	 
+	    Usage:
+	       results=parseresultsfromdiskioserial(filename)
+	"""
+
+	#Open file
+	try:
+		fid=open(filename,'rb')
+	except IOError as e:
+		raise IOError("loadresultsfromdisk error message: could not open '%s' for binary reading." % filename)
+
+	results={}
+
+	#Read fields until the end of the file.
+	result=ReadData(fid)
+	while result:
+		#Get time and step
+		if not result['step'] in results:
+			results[result['step']]={}
+			results[result['step']]['step']=result['step']
+			results[result['step']]['time']=result['time'] 
+	
+		#Add result
+		if result['step'] in results and \
+		   result['fieldname'] in results[result['step']] and \
+		   not strcmp(result['fieldname'],'SolutionType'):
+			results[result['step']][result['fieldname']]=numpy.concatenate((results[result['step']][result['fieldname']],result['field']),axis=0)
+		else:
+			results[result['step']][result['fieldname']]=result['field']
+
+		#read next result
+		result=ReadData(fid)
+
+	fid.close()
+
+	return results
+	# }}}
+
+def parseresultsfromdiskiosplit(filename):    # {{{
+	"""
+	PARSERESULTSFROMDISKIOSPLIT - ...
+	 
+	    Usage:
+	       results=parseresultsfromdiskiosplit(filename)
+	"""
+
+	#Open file
+	try:
+		fid=open(filename,'rb')
+	except IOError as e:
+		raise IOError("loadresultsfromdisk error message: could not open '%s' for binary reading." % filename)
+
+	results={}
+
+	#if we have done split I/O, ie, we have results that are fragmented across patches, 
+	#do a first pass, and figure out the structure of results
+	result=ReadDataDimensions(fid)
+	while result:
+
+		#Get time and step
+		if not result['step'] in results:
+			results[result['step']]={}
+			results[result['step']]['step']=result['step']
+			results[result['step']]['time']=result['time'] 
+
+		#Add result
+		if strcmpi(result['fieldname'],'Patch'):
+			results[result['step']][result['fieldname']]=[0,result['N']]
+		else:
+			results[result['step']][result['fieldname']]=float('NaN')
+
+		#read next result
+		result=ReadDataDimensions(fid)
+
+	#do a second pass, and figure out the size of the patches
+	fid.seek(0)    #rewind
+	result=ReadDataDimensions(fid)
+	while result:
+
+		#Add result
+		if strcmpi(result['fieldname'],'Patch'):
+			patchdimensions=results[result['step']][result['fieldname']]
+			results[result['step']][result['fieldname']]=[patchdimensions[0]+result['M'],result['N']]
+
+		#read next result
+		result=ReadDataDimensions(fid)
+
+	#allocate patches
+	for result in results.itervalues():
+		if 'Patch' in result:
+			result['Patch']=numpy.zeros(shape=(result['Patch'][0],result['Patch'][1]),dtype=float)
+			result['counter']=0    #use to index into the patch
+
+	#third pass, this time to read the real information
+	fid.seek(0)    #rewind
+	result=ReadData(fid)
+	while result:
+
+		#Get time and step
+		if not result['step'] in results:
+			results[result['step']]={}
+			results[result['step']]['step']=result['step']
+			results[result['step']]['time']=result['time'] 
+
+		#Add result
+		if strcmpi(result['fieldname'],'Patch'):
+			counter=results[result['step']]['counter']
+			counter2=counter+result['field'].shape[0]-1
+			results[result['step']][result['fieldname']][counter:counter2,:]=result['field']
+
+			#increment counter: 
+			results[result['step']]['counter']=counter2+1
+		else:
+			results[result['step']][result['fieldname']]=result['field']
+
+		#read next result
+		result=ReadData(fid)
+
+	#close file
+	fid.close()
+
+	return results
+	# }}}
+
+def ReadData(fid):    # {{{
+	"""
+	READDATA - ...
+	 
+	    Usage:
+	       field=ReadData(fid)
+	"""
+
+	#read field
+	try:
+		length=struct.unpack('i',fid.read(struct.calcsize('i')))[0]
+
+		fieldname=struct.unpack('%ds' % length,fid.read(length))[0][:-1]
+		time=struct.unpack('d',fid.read(struct.calcsize('d')))[0]
+		step=struct.unpack('i',fid.read(struct.calcsize('i')))[0]
+
+		type=struct.unpack('i',fid.read(struct.calcsize('i')))[0]
+		M=struct.unpack('i',fid.read(struct.calcsize('i')))[0]
+		if   type==1:
+			field=numpy.array(struct.unpack('%dd' % M,fid.read(M*struct.calcsize('d'))),dtype=float)
+		elif type==2:
+			field=struct.unpack('%ds' % M,fid.read(M))[0][:-1]
+		elif type==3:
+			N=struct.unpack('i',fid.read(struct.calcsize('i')))[0]
+#			field=transpose(fread(fid,[N M],'double'));
+			field=numpy.zeros(shape=(M,N),dtype=float)
+			for i in xrange(M):
+				field[i,:]=struct.unpack('%dd' % N,fid.read(N*struct.calcsize('d')))
+		else:
+			raise TypeError("cannot read data of type %d" % type)
+
+		result={}
+		result['fieldname']=fieldname
+		result['time']=time
+		result['step']=step
+		result['field']=field
+
+	except struct.error as e:
+		result={}
+
+	return result
+	# }}}
+
+def ReadDataDimensions(fid):    # {{{
+	"""
+	READDATADIMENSIONS - read data dimensions, step and time, but not the data itself.
+	 
+	    Usage:
+	       field=ReadDataDimensions(fid)
+	"""
+
+	#read field
+	try:
+		length=struct.unpack('i',fid.read(struct.calcsize('i')))[0]
+
+		fieldname=struct.unpack('%ds' % length,fid.read(length))[0][:-1]
+		time=struct.unpack('d',fid.read(struct.calcsize('d')))[0]
+		step=struct.unpack('i',fid.read(struct.calcsize('i')))[0]
+
+		type=struct.unpack('i',fid.read(struct.calcsize('i')))[0]
+		M=struct.unpack('i',fid.read(struct.calcsize('i')))[0]
+		N=1    #default
+		if   type==1:
+			fid.seek(M*8,1)
+		elif type==2:
+			fid.seek(M,1)
+		elif type==3:
+			N=struct.unpack('i',fid.read(struct.calcsize('i')))[0]
+			fid.seek(N*M*8,1)
+		else:
+			raise TypeError("cannot read data of type %d" % type)
+
+		result={}
+		result['fieldname']=fieldname
+		result['time']=time
+		result['step']=step
+		result['M']=M
+		result['N']=N
+
+	except struct.error as e:
+		result={}
+
+	return result
+	# }}}
+
Index: issm/branches/trunk-jpl-damage/src/m/model/petscversion.py
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/petscversion.py	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/petscversion.py	(revision 12878)
@@ -0,0 +1,34 @@
+import os
+from issmdir import *
+from MatlabFuncs import *
+
+def petscversion():
+	"""
+	PETSCVERSION - recover petsc version number, inside config.h file
+ 
+	    Usage:
+	        PETSC_VERSION=petscversion();
+	"""
+
+	#default
+	PETSC_VERSION=3
+
+	configfile=os.path.join(issmdir(),'config.h')
+	if not os.path.exists(configfile):
+		raise RuntimeError("File '%s' not found. ISSM has not been configured yet!" % configfile)
+
+	#go through the file, and recover the line we want
+	try:
+		fid=open(configfile,'r')
+	except IOError as e:
+		raise IOerror("could not open file: '%s'" % configfile)
+
+	for tline in fid:
+		if strncmp(tline,'#define _PETSC_MAJOR_',21):
+			PETSC_VERSION=int(tline[22])
+			break
+
+	fid.close()
+
+	return PETSC_VERSION
+
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/applyoptions.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/applyoptions.m	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/applyoptions.m	(revision 12878)
@@ -31,20 +31,16 @@
 end
 
-%xlabel
+%xlabel, ylabel and zlabel
 if exist(options,'xlabel');
 	xlabel(getfieldvalue(options,'xlabel'),'FontSize',fontsize,'FontWeight',fontweight);
 end
-
-%ylabel
 if exist(options,'ylabel');
 	ylabel(getfieldvalue(options,'ylabel'),'FontSize',fontsize,'FontWeight',fontweight);
 end
-
-%zlabel
 if exist(options,'zlabel');
 	zlabel(getfieldvalue(options,'zlabel'),'FontSize',fontsize,'FontWeight',fontweight);
 end
 
-%xtikcs
+%xticks, yticks and zticks
 if exist(options,'xtick'), set(gca,'XTick',getfieldvalue(options,'xtick')); end
 if exist(options,'ytick'), set(gca,'YTick',getfieldvalue(options,'ytick')); end
@@ -75,5 +71,5 @@
 end
 
-%xlim
+%xlim, ylim and zlim
 if exist(options,'xlim');
 	xlim(getfieldvalue(options,'xlim'));
@@ -83,4 +79,7 @@
 if exist(options,'ylim');
 	ylim(getfieldvalue(options,'ylim'));
+end
+if exist(options,'zlim');
+	zlim(getfieldvalue(options,'zlim'));
 end
 
@@ -92,10 +91,4 @@
 end
 
-
-%zlim
-if exist(options,'zlim');
-	zlim(getfieldvalue(options,'zlim'));
-end
-
 %Basinzoom
 if exist(options,'basin');
@@ -107,5 +100,4 @@
 	showbasins(options);
 end
-
 
 %Caxis
@@ -127,16 +119,6 @@
 
 %colormap
-if exist(options,'colormap'),
-	cname=getfieldvalue(options,'colormap');
-	if strcmpi(cname,'Ala'),
-		c = jet(64);
-		c = c (32:end,:);
-	elseif strcmpi(cname,'redblue'),
-		%m = 30;
-		%n = fix(0.5*m);
-		%r = [(0:1:n-1)/n,ones(1,n)];
-		%g = [(0:n-1)/n, (n-1:-1:0)/n];
-		%b = [ones(1,n),(n-1:-1:0)/n];
-		%c = [r(:), g(:), b(:)]; 
+c = getcolormap(options);
+h = colormap(c);
 
 		c = hsv(64);
@@ -302,5 +284,5 @@
 		textpositioni=textposition{i};
 		textrotationi=textrotation{i};
-		h=text(textpositioni(1),textpositioni(2),textstringi,'FontSize',textsizei,'FontWeight',textweighti,'Color',textcolori,'Rotation',textrotationi);
+		h=text(textpositioni(1),textpositioni(2),10,textstringi,'FontSize',textsizei,'FontWeight',textweighti,'Color',textcolori,'Rotation',textrotationi);
 		set(h,'Clipping','on'); %prevent text from appearing outside of the box
 	end
@@ -359,4 +341,5 @@
 if exist(options,'axispos'),
 	Axis=getfieldvalue(options,'axispos');
+	hold on
 	set(gca,'pos',Axis);
 end
@@ -384,4 +367,8 @@
 			left=screen(1); bott=screen(2); widt=screen(3); heig=screen(4)-25;
 			set(gcf,'Position',fix([left bott widt/2 heig]));
+		elseif strcmpi(figposition,'square'),
+			screen=get(0,'ScreenSize');
+			left=screen(1); bott=screen(2); widt=min(screen(3)-25,screen(4)-25);
+			set(gcf,'Position',fix([left+(screen(3)-widt) bott widt widt]));
 		elseif strcmpi(figposition,'portrait'),
 			%reformat with letter paper size (8.5" x 11")
@@ -426,4 +413,6 @@
 		A=expread([ jplsvn() '/projects/Exp/GreenlandBoxFront.exp']);
 		[A.x A.y]=ll2xy(A.x,A.y,+1,45,70);
+		A.x = A.x(1:30:end);
+		A.y = A.y(1:30:end);
 	elseif strcmpi(md.mesh.hemisphere,'s') | strcmpi(md.mesh.hemisphere,'south'),
 		%A=expread([ jplsvn() '/projects/Exp/Antarctica.exp']);
@@ -444,5 +433,5 @@
 	line(A.x,A.y,ones(size(A.x)),'color','b');
 	patch([Ax(1)  Ax(2)  Ax(2)  Ax(1) Ax(1)],[Ay(1)  Ay(1)  Ay(2)  Ay(2) Ay(1)],[1 1 1],'EdgeColor',[0 0 0],'LineWidth',1,'FaceLighting','none')
-	patch( [mdx(1) mdx(2) mdx(2) mdx(1)],[mdy(1) mdy(1) mdy(2) mdy(2)],ones(4,1),'EdgeColor',[0 0 0],'FaceColor','r','FaceAlpha',0.5)
+	patch([mdx(1) mdx(2) mdx(2) mdx(1)],[mdy(1) mdy(1) mdy(2) mdy(2)],ones(4,1),'EdgeColor',[0 0 0],'FaceColor','r','FaceAlpha',0.5)
 	colorbar('off');
 	%back to main gca
@@ -452,13 +441,20 @@
 %flag edges of a partition
 if exist(options,'partitionedges')
-[xsegments ysegments]=flagedges(md.mesh.elements,md.mesh.x,md.mesh.y,md.qmu.partition);
-xsegments=xsegments*getfieldvalue(options,'unit',1);
-ysegments=ysegments*getfieldvalue(options,'unit',1);
-color=getfieldvalue(options,'partitionedgescolor','r-');
-linewidth=getfieldvalue(options,'linewidth',1);
-hold on;
-for i=1:length(xsegments),
-	plot(xsegments(i,:),ysegments(i,:),color,'LineWidth',linewidth);
-end
+	[xsegments ysegments]=flagedges(md.mesh.elements,md.mesh.x,md.mesh.y,md.qmu.partition);
+	xsegments=xsegments*getfieldvalue(options,'unit',1);
+	ysegments=ysegments*getfieldvalue(options,'unit',1);
+	color=getfieldvalue(options,'partitionedgescolor','r-');
+	linewidth=getfieldvalue(options,'linewidth',1);
+	hold on;
+	for i=1:length(xsegments),
+		plot(xsegments(i,:),ysegments(i,:),color,'LineWidth',linewidth);
+	end
+end
+
+%Scatter
+if exist(options,'scatter')
+	data=getfieldvalue(options,'scatter');
+	hold on
+	plot_scatter(data(:,1),data(:,2),getfieldvalue(options,'scattersize',3),data(:,3),options);
 end
 
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/colormaps/getcolormap.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/colormaps/getcolormap.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/colormaps/getcolormap.m	(revision 12878)
@@ -0,0 +1,55 @@
+function map = getcolormap(options)
+%GETCOLORMAP - get colormap from options
+%
+%   Usage:
+%      map = getcolormap(options)
+
+%default is jet
+if ~exist(options,'colormap'),
+	map = jet;
+	return
+end
+
+map = getfieldvalue(options,'colormap');
+if isnumeric(map);
+	%user provided a full colormap
+	return;
+end
+
+%OK this is an in-house colormap
+if ~ischar(map), error('colormap format not supported'); end
+
+if strcmpi(map,'Ala'),
+	map = jet(256);
+	map = map(128:end,:);
+elseif strcmpi(map,'redblue'),
+	map = hsv(256);
+	map = rgb2hsv(map);
+	map(:,2)       = max(min( abs(map(:,1)-0.5)/0.5 ,1),0);
+	map(1:128,1)   = 0.7;
+	map(129:end,1) = 1;
+	map = hsv2rgb(map);
+elseif strcmpi(map,'Rignot'),
+	alpha=getfieldvalue(options,'alpha',1);
+	map = hsv(256);
+	map = rgb2hsv(map);
+	map(:,2) = max(min( (0.1+map(:,1)).^(1/alpha) ,1),0);
+	map = hsv2rgb(map);
+elseif strcmpi(map,'Rignot2'),
+	alpha=getfieldvalue(options,'alpha',1);
+	map = hsv(256);
+	map = rgb2hsv(map);
+	map(:,2) = max(min( (0.1+map(:,1)).^(1/alpha) ,1),0);
+	map = hsv2rgb(map);
+	map=flipud(map);
+elseif strcmpi(map,'Seroussi'),
+	alpha=getfieldvalue(options,'alpha',1);
+	map = hsv(256);
+	map = flipud(map);
+	map = map(1:floor(0.7*size(map,1)),:);
+	map = rgb2hsv(map);
+	map(:,2) = max(min( (0.1+map(:,1)).^(1/alpha) ,1),0);
+	map = hsv2rgb(map);
+else
+	eval(['map = ' map ';']);
+end
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/colormaps/haxby.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/colormaps/haxby.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/colormaps/haxby.m	(revision 12878)
@@ -0,0 +1,36 @@
+function map = haxby(m);
+%HAXBY - Haxby color map
+%   HAXBY(M) returns an M-by-3 matrix containing a colormap with Haxby's
+%   colors, commonly used for displaying bathymetry data.
+%   HAXBY, by itself, is the same length as the current colormap.
+%
+%   Colormap is based on the colors used by W. F. Haxby's Gravity
+%   field of World's oceans, 1985, developed for geoid and gravity maps.
+%   The version used here is formed from a linear interpolation of
+%   the GMT color table used by MB-System by David W. Caress and Dale N. Chayes.
+%   <http://www.ldeo.columbia.edu/res/pi/MB-System>
+
+if nargin < 1, m = size(get(gcf,'colormap'),1); end
+
+ncolors=11;
+c=[...
+	37     57   175
+	40    127   251
+	50    190   255
+	106   235   255
+	138   236   174
+	205   255   162
+	240   236   121
+	255   189    87
+	255   161    68
+	255   186   133
+	255   255   255];
+
+pp=1:(m-1)/(ncolors-1):m;
+r=interp1(pp,c(:,1),1:m);
+g=interp1(pp,c(:,2),1:m);
+b=interp1(pp,c(:,3),1:m);
+map=[r' g' b']/255;
+
+%Fix bug of interp1 (M. Morlighem)
+map(find(map>1))=1;
Index: issm/branches/trunk-jpl-damage/src/m/model/plot/colormaps/lbmap.m
===================================================================
--- issm/branches/trunk-jpl-damage/src/m/model/plot/colormaps/lbmap.m	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/m/model/plot/colormaps/lbmap.m	(revision 12878)
@@ -0,0 +1,109 @@
+function map = lbmap(n,scheme)
+%LBMAP Returns specified Light-Bertlein colormap.
+%
+%   LBMAP(N,SCHEME) returns an Nx3 colormap. SCHEME can be one of the
+%   following strings:
+%
+%       'Blue'       Single-hue progression to purlish-blue (default)
+%       'BlueGray'   Diverging progression from blue to gray
+%       'BrownBlue'  Orange-white-purple diverging scheme
+%       'RedBlue'    Modified spectral scheme
+%
+%   If N is not specified, the size of the colormap is determined by the
+%   current figure. If no figure exists, MATLAB creates one.
+%
+%Example 1: 7-color single-hue blue (default)
+%   load penny
+%   imagesc(P)
+%   colormap(lbmap(7))
+%   colorbar
+%
+%Example 2: 11-color modified spectrum
+%   load penny
+%   imagesc(P)
+%   colormap(lbmap(11,'RedBlue'))
+%   colorbar
+%
+%   See also HSV, GRAY, HOT, BONE, COPPER, PINK, FLAG, COLORMAP, RGBPLOT.
+
+% Reference:
+% A. Light & P.J. Bartlein, "The End of the Rainbow? Color Schemes for
+% Improved Data Graphics," Eos,Vol. 85, No. 40, 5 October 2004.
+% http://geography.uoregon.edu/datagraphics/EOS/Light&Bartlein_EOS2004.pdf
+
+% Copyright 2007-2010 The MathWorks, Inc.
+
+%defensive programming
+error(nargchk(0,2,nargin))
+error(nargoutchk(0,1,nargout))
+
+%defaults
+if nargin<2
+	scheme = 'Blue';
+end
+if nargin<1
+	n = size(get(gcf,'colormap'),1);
+end
+
+%valid schemes
+switch lower(scheme)
+	case 'blue'
+		baseMap = BlueMap;
+	case 'bluegray'
+		baseMap = BlueGrayMap;
+	case 'brownblue'
+		baseMap = BrownBlueMap;
+	case 'redblue'
+		baseMap = RedBlueMap;
+	otherwise
+		error(['Invalid scheme ' scheme])
+	end
+	idx1 = linspace(0,1,size(baseMap,1));
+	idx2 = linspace(0,1,n);
+	map = interp1(idx1,baseMap,idx2);
+
+function baseMap = BlueMap
+	baseMap = [243 246 248;
+	224 232 240;
+	171 209 236;
+	115 180 224;
+	35 157 213;
+	0 142 205;
+	0 122 192]/255;
+
+function baseMap = BlueGrayMap
+	%DivergingBlueGray
+	baseMap = [  0 170 227;
+	53 196 238;
+	133 212 234;
+	190 230 242;
+	217 224 230;
+	146 161 170;
+	109 122 129;
+	65  79  81]/255;
+
+function baseMap = BrownBlueMap
+	baseMap = [144 100  44;
+	187 120  54;
+	225 146  65;
+	248 184 139;
+	244 218 200;
+	241 244 245;
+	207 226 240;
+	160 190 225;
+	109 153 206;
+	70  99 174;
+	24  79 162]/255;
+
+function baseMap = RedBlueMap
+	baseMap = [175  53  71;
+	216  82  88;
+	239 133 122;
+	245 177 139;
+	249 216 168;
+	242 238 197;
+	216 236 241;
+	154 217 238;
+	68 199 239;
+	0 170 226;
+	0 116 188]/255;
